<?php
namespace Ep\Wp;

use Ep\Cache\AbstractCacheFactory;
use Zend\ServiceManager\AbstractFactory\ReflectionBasedAbstractFactory;
use Zend\ServiceManager\Factory\InvokableFactory;

return [
    'dependencies' => [
        'aliases' => [
            'wp'           => WordPress::class,
            'wp.installer' => Middleware\Installer::class,
            'wp.bootstrap' => Middleware\Bootstrap::class,
            'wp.theme'     => Middleware\Theme::class,

        ],

        'factories' => [
            WordPress::class            => ReflectionBasedAbstractFactory::class,
            Middleware\Installer::class => InvokableFactory::class,
            Middleware\Bootstrap::class => Middleware\BootstrapFactory::class,
            Middleware\Theme::class     => InvokableFactory::class,

            Plugin\PluginManager::class       => Plugin\PluginManagerFactory::class,
            Plugin\TwigExtension::class       => InvokableFactory::class,
            Widget\WidgetPluginManager::class => Widget\WidgetPluginManagerFactory::class,

            'wp.i18n.cache' => AbstractCacheFactory::class,
        ],
    ],
];