<?php
namespace Ep\Wp;

use Ep\View\Renderer\RendererAwareInitializer;
use Zend\ConfigAggregator\ArrayProvider;
use Zend\ConfigAggregator\ConfigAggregator;
use Zend\ConfigAggregator\PhpFileProvider;

/**
 * Class ConfigProvider
 *
 * @package Ep\Wp
 * @author Elektronika Perhoč <support@ep.hr>
 * @link https://bitbucket.org/elektronika-perhoc/ep-wordpress
 */
class ConfigProvider
{
    /**
     * Vraća konfiguraciju.
     *
     * @return array
     */
    public function __invoke()
    {
        return (new ConfigAggregator([
            new ArrayProvider([
                'wp_plugins' => [
                    'initializers' => [
                        RendererAwareInitializer::class,
                    ],
                ],
            ]),
            new PhpFileProvider(__DIR__ . '/../config/*.config.php'),
        ]))->getMergedConfig();
    }
}