<?php
namespace Ep\Wp\Middleware;

use Ep\Middleware\BaseUrl;
use Interop\Http\Server\MiddlewareInterface;
use Interop\Http\Server\RequestHandlerInterface;
use Psr\Http\Message\ResponseInterface;
use Psr\Http\Message\ServerRequestInterface;
use Zend\Diactoros\Response\RedirectResponse;

/**
 * WordPress installer
 *
 * @package Ep\Wp\Middleware
 * @author Elektronika Perhoč <support@ep.hr>
 * @link https://bitbucket.org/elektronika-perhoc/ep-wordpress
 */
class Installer implements MiddlewareInterface
{
    /**
     * Automatizira instalaciju WordPressa.
     *
     * @param ServerRequestInterface $request
     * @param RequestHandlerInterface $handler
     *
     * @return ResponseInterface|RedirectResponse
     */
    public function process(ServerRequestInterface $request, RequestHandlerInterface $handler)
    {
        if (defined('WP_INSTALLING')) {
            switch (intval($_GET['step'] ?? '')) {
                case 0:
                    require_once ABSPATH . 'wp-admin/includes/file.php';
                    require_once ABSPATH . 'wp-admin/includes/translation-install.php';

                    wp_download_language_pack('hr');

                    $uri = $request->getUri();
                    return new RedirectResponse(
                        $uri->withPath($request->getAttribute(BaseUrl::BASE_URL) . $uri->getPath())
                            ->withQuery('language=hr&step=1')
                    );
                case 1:
                    $_POST['weblog_title'] = $this->config['name'] ?? 'EP WordPress';
                    $_POST['user_name'] = 'Elektronika Perhoc';
                    $_POST['admin_password'] = 'Elektr0nik@Perh0c';
                    $_POST['admin_password2'] = 'Elektr0nik@Perh0c';
                    $_POST['admin_email'] = $this->config['email'] ?? 'web@ep.hr';
                    $_POST['blog_public'] = 1;
                    $_GET['step'] = 2;
                    break;
            }
        }

        return $handler->handle($request);
    }
}