<?php
namespace Ep\Wp\Middleware;

use Interop\Http\Server\MiddlewareInterface;
use Interop\Http\Server\RequestHandlerInterface;
use Psr\Http\Message\ResponseInterface;
use Psr\Http\Message\ServerRequestInterface;
use Zend\Diactoros\Response\HtmlResponse;

/**
 * Učitava WordPress temu.
 *
 * @package Ep\Wp\Middleware
 * @author Elektronika Perhoč <support@ep.hr>
 * @link https://bitbucket.org/elektronika-perhoc/ep-wordpress
 */
class Theme implements MiddlewareInterface
{
    /**
     * Vraća odgovor s renderiranom WordPress temom.
     *
     * @param ServerRequestInterface $request
     * @param RequestHandlerInterface $handler
     *
     * @return ResponseInterface|HtmlResponse
     */
    public function process(ServerRequestInterface $request, RequestHandlerInterface $handler)
    {
        if (
            defined('WP_ADMIN') || defined('WP_INSTALLING')
            || basename($request->getUri()->getPath()) === 'wp-login.php'
        ) {
            return $handler->handle($request);
        }

        if (!defined('WP_USE_THEMES')) {
            define('WP_USE_THEMES', true);
        }

        wp();

        ob_start();
        require_once ABSPATH . WPINC . '/template-loader.php';
        return new HtmlResponse(ob_get_clean());
    }
}