<?php
namespace Ep\Wp\Plugin;

use WP_Post;

/**
 * Omogućuje dodavanje metapodataka postova u dokument.
 *
 * @package Ep\Wp\Plugin
 * @author Elektronika Perhoč <support@ep.hr>
 * @link https://bitbucket.org/elektronika-perhoc/ep-wordpress
 */
class DocumentMeta implements PluginInterface
{
    /**
     * Dodaje akcije i filtere u WordPress.
     *
     * @return void
     */
    public function __invoke(): void
    {
        add_action('wp_head', [$this, 'wp_head']);
    }

    /**
     * Renderira meta tagove.
     */
    public function wp_head()
    {
        global $post;

        if (!$post instanceof WP_Post) {
            return;
        }

        if ($description = get_post_meta($post->ID, '_meta_description', true)) {
            printf('<meta name="description" content="%s">%s', esc_attr($description), PHP_EOL);
        }

        if ($keywords = get_post_meta($post->ID, '_meta_keywords', true)) {
            printf('<meta name="keywords" content="%s">%s', esc_attr($keywords), PHP_EOL);
        }
    }
}