<?php
namespace Ep\Wp\Plugin;

use Ep\Twig\View\ViewPluginManager;
use Ep\Wp\View\ViewInterface;

/**
 * Omogućava korištenje EP viewova.
 *
 * @package Ep\Wp\Plugin
 * @author Elektronika Perhoč <support@ep.hr>
 * @link https://bitbucket.org/elektronika-perhoc/ep-wordpress
 */
class Views implements PluginInterface
{
    /** @var ViewPluginManager */
    private $views;
    /** @var array */
    private $config;

    /**
     * Views constructor.
     *
     * @param ViewPluginManager $views
     * @param array $config
     */
    public function __construct(ViewPluginManager $views, array $config)
    {
        $this->views = $views;
        $this->config = $config['wordpress'] ?? [];
    }

    /**
     * Dodaje akcije i filtere u WordPress.
     *
     * @return void
     */
    public function __invoke(): void
    {
        add_action('init', [$this, 'init']);
    }

    /**
     * Inicijalizira registrirane viewove.
     */
    public function init(): void
    {
        foreach ($this->config['views'] ?? [] as $name) {
            /** @var ViewInterface $view */
            $view = $this->views->get($name);
            $view->init();
        }
    }
}