<?php
namespace Ep\Wp;

use Psr\Container\ContainerInterface;
use Zend\Stratigility\MiddlewarePipe;

/**
 * WordPress Middleware.
 *
 * Ovaj middleware je potrebno pokrenuti umjesto wp-config.php datoteke.
 *
 * @package Ep\WordPress
 * @author Elektronika Perhoč <support@ep.hr>
 * @link https://bitbucket.org/elektronika-perhoc/ep-wordpress
 */
class WordPress extends MiddlewarePipe
{
    /** @var array */
    private $config;

    /**
     * WordPress constructor.
     *
     * @param ContainerInterface $container
     * @param array $config
     *
     * @throws \Psr\Container\ContainerExceptionInterface
     * @throws \Psr\Container\NotFoundExceptionInterface
     */
    public function __construct(ContainerInterface $container, array $config)
    {
        parent::__construct();

        $this->config = $config['wp'] ?? [];

        $this->pipe($container->get('wp.bootstrap'));
        $this->pipe($container->get('wp.installer'));
        $this->pipe($container->get('wp.theme'));
    }
}